use crate::vm::module::DmFunction;
use crate::vm::DmValue::*;
use crate::vm::{DmObject, DmValue, DmVirtualMachine};

fn get_method<'a>(ptr: *mut DmObject, name: String) -> Option<&'a DmFunction> {
    unsafe {
        (*ptr).object_type.methods.get(&name)
    }
}

fn get_rust_string_from_dm_object(ptr: &*mut DmObject) -> String {
    unsafe {
        let dm_object = Box::from_raw(*ptr);
        format!("{}@{:?}", dm_object.object_type.name, dm_object.data)
    }
}

fn get_rust_string_from_dm_string(ptr: *mut DmObject) -> String {
    unsafe {
        let dm_string = Box::from_raw(ptr);
        todo!()
    }
}

pub fn dm_print(args: Vec<DmValue>, vm: &mut DmVirtualMachine) -> DmValue {
    if args.len() != 1 {
        return DmUnit // TODO: make exception
    }
    match &args[0] {
        DmByte(b) => {
            print!("{}", *b);
        }
        DmInt(i) => {
            print!("{}", *i);
        }
        DmLong(l) => {
            print!("{}", *l);
        }
        DmDouble(d) => {
            print!("{}", *d);
        }
        DmBoolean(b) => {
            print!("{}", *b);
        }
        DmPointer(ptr) => {
            if let Some(to_string) = get_method(*ptr, String::from("to_string")) {
                let call_result = vm.call(&to_string, vec![args[0].clone()]);
                match call_result {
                    DmPointer(dm_string_ptr) => {
                        let string = get_rust_string_from_dm_string(dm_string_ptr);
                        print!("{}", string);
                    }
                    _ => {
                        // TODO: vm throw or return exception?
                    }
                }
            } else {
                print!("{}", get_rust_string_from_dm_object(ptr));
            }
        },
        DmByteArray(bs) => {

        }
        DmIntArray(is) => {

        }
        DmLongArray(ls) => {}
        DmDoubleArray(ds) => {}
        DmBooleanArray(bs) => {}
        DmPointerArray(ptrs) => {}
        DmUnit => {
            print!("Unit")
        },
    }
    DmUnit
}
